/*****************************************************************************
**																			**
**	 Name: 	FIO pins, Interrupts, and Timer in C							**
**																			**
******************************************************************************

(C) Copyright 2006 - Analog Devices, Inc.  All rights reserved.

Project Name:	BF533 Flags C

Date Modified:	3/31/03		Ver 1.01

Software:		VisualDSP++ 4.5

Hardware:		ADSP-BF533 EZ-KIT Lite

Connections:	Switch SW9_1 has to be turned on in order to connect SW7 to PF8

Purpose:		To demonstrate the configuration of FIO pins, Timer, and
				Interrupts in C

				
				
				ACHTUNG !!!! OPTIMIERUNG IST AUSGESTELLT!!!!!!
				
Naechste Schritte:
- PLL in Betrieb nehmen, siehe Hardware Manual ab Seite 333
- SDRAM in Betrieb nehmen
- UART? oder PPI?
*****************************************************************************/

//#include "BF533 Flags.h"
#include <cdefBF532.h>
#include <services/services.h>
#include "PowerInit.h"
#include "ccblkfn.h"
#include "sysreg.h"

//--------------------------------------------------------------------------//
// Variables																//
//--------------------------------------------------------------------------//
// flag indicating direction of moving light (toggled in FlagA ISR)
short sLight_Move_Direction = 0;

//--------------------------------------------------------------------------//
// Function:	main														//
//--------------------------------------------------------------------------//
//SDRAM Setup

void main(void)
{

	sysreg_write(reg_SYSCFG, 0x32);		//Initialize System Configuration Register
	Init();
		
	int i=0;
	int x=0;

	*pFIO_DIR = 0xFFFF;	//Direction-Register, alle auf Output

	volatile long int * p = 0x0000;
	
	for(i=0;i<1000;i++) {
		p[i] = i;
        ssync();
	}
	
	int k;	
	for(k=0;k<0x0005;k++) {
	    *pFIO_FLAG_S = 0xFFFF;
		delay(100);
	    *pFIO_FLAG_C = 0xFFFF;
		delay(100);
	}
	
	while(1) {
	    	x++;
	    	if(x>1000) x=0;
	    	p[x] = x;
	    	
	    	*pFIO_FLAG_D = 0xFFFF & p[x];
	    	ssync();
	    	
	    	delay(1);
	}
}
